<?php

/**
 * @file
 * Handle mailing functionality of follow and unfollow module.
 */

/**
 * Implements hook_send_mail() for follow_unfollow_send_mail().
 */
function follow_unfollow_send_mail($source = NULL, $type = NULL, $data = NULL) {
  $module = 'follow_unfollow';
  $key = $source;
  $from = variable_get('site_mail');

  // Follow and unfollow functionality the user will be login user.
  if ($source == 'follow' || $source == 'unfollow') {
    global $user;
    $user_data = user_load($user->uid);
    $to = $user->mail;
  }

  $language = language_default();
  $send = TRUE;

  if ($type == 'node') {
    $url = url('node/' . $data->nid, array('absolute' => TRUE));
    $title = '"' . $data->title . '"';
  }
  elseif ($type == 'taxonomy') {
    $url = url('taxonomy/' . $data->tid, array('absolute' => TRUE));
    $title = '"' . $data->name . '"';
  }
  elseif ($type == 'user') {
    $url = url('user/' . $data->uid, array('absolute' => TRUE));
    $title = '"' . $data->name . '"';
  }

  $params = array(
    '@username' => ucfirst($user_data->name),
    '@url' => isset($url) ? $url : '',
    '@title' => isset($title) ? $title : '',
  );

  drupal_mail($module, $key, $to, $language, $params, $from, $send, TRUE);
}

/**
 * Used for creating subject and body of mail.
 */
function follow_unfollow_mail($key, &$message, $params) {
  switch ($key) {
    case 'follow':
      $subject = variable_get('follow_unfollow_subject_of_follow');
      $body = variable_get('follow_unfollow_body_of_follow');

      $message['subject'] = format_string($subject, $params);
      $message['body'][] = format_string($body, $params);

      break;

    case 'unfollow':
      $subject = variable_get('follow_unfollow_subject_of_unfollow');
      $body = variable_get('follow_unfollow_body_of_unfollow');

      $message['subject'] = format_string($subject, $params);
      $message['body'][] = format_string($body, $params);

      break;
  }
}
