<?php

/**
 * @file
 * Views integration for the follow statistics.
 */

/**
 * Implements hook_views_data() for follow_unfollow_views_data().
 */
function follow_unfollow_views_data() {
  $data = array();

  $data['follow_unfollow_statistics'] = array(
    'table' => array(
      'base' => array(
        'field' => 'fid',
        'title' => 'Follow Unfollow Statistics',
        'help' => 'TODO: please describe the items in this table!',
      ),
      'group' => 'followunfollow',
    ),
    'fid' => array(
      'title' => 'Id',
      'help' => 'The follow id ',
      'field' => array(
        'handler' => 'views_handler_field_numeric',
        'click sortable' => FALSE,
      ),
      'filter' => array(
        'handler' => 'views_handler_filter_numeric',
      ),
      'sort' => array(
        'handler' => 'views_handler_sort',
      ),
    ),
    'nid' => array(
      'title' => 'Nid',
      'help' => 'Node id of follow & unfollow page',
      'field' => array(
        'handler' => 'views_handler_field',
        'click sortable' => FALSE,
      ),
      'filter' => array(
        'handler' => 'views_handler_filter_numeric',
      ),
      'sort' => array(
        'handler' => 'views_handler_sort',
      ),
      'relationship' => array(
        'base' => 'node',
        'field' => 'nid',
        'handler' => 'views_handler_relationship',
        'label' => t('node'),
      ),
      'argument' => array(
        'handler' => 'views_handler_argument_nid',
        'numeric' => TRUE,
        'validate type' => 'nid',
      ),
    ),
    'tid' => array(
      'title' => 'Tid',
      'help' => 'Taxonomy id of follow & unfollow page',
      'field' => array(
        'handler' => 'views_handler_field',
        'click sortable' => FALSE,
      ),
      'filter' => array(
        'handler' => 'views_handler_filter_numeric',
      ),
      'sort' => array(
        'handler' => 'views_handler_sort',
      ),
      'relationship' => array(
        'base' => 'taxonomy_term_data',
        'field' => 'tid',
        'handler' => 'views_handler_relationship',
        'label' => t('taxonomy'),
      ),
      'argument' => array(
        'handler' => 'views_handler_argument_tid',
        'numeric' => TRUE,
        'validate type' => 'tid',
      ),
    ),
    'uid' => array(
      'title' => 'Uid',
      'help' => 'Target User id of follow & unfollow page',
      'field' => array(
        'handler' => 'views_handler_field',
        'click sortable' => FALSE,
      ),
      'filter' => array(
        'handler' => 'views_handler_filter_numeric',
      ),
      'sort' => array(
        'handler' => 'views_handler_sort',
      ),
      'relationship' => array(
        'base' => 'users',
        'field' => 'uid',
        'handler' => 'views_handler_relationship',
        'label' => t('Target user'),
      ),
      'argument' => array(
        'handler' => 'views_handler_argument_uid',
        'numeric' => TRUE,
        'validate type' => 'uid',
      ),
    ),
    'author_uid' => array(
      'title' => 'Author Uid',
      'help' => 'Author User id of follow & unfollow page',
      'field' => array(
        'handler' => 'views_handler_field',
        'click sortable' => FALSE,
      ),
      'filter' => array(
        'handler' => 'views_handler_filter_numeric',
      ),
      'sort' => array(
        'handler' => 'views_handler_sort',
      ),
      'relationship' => array(
        'base' => 'users',
        'field' => 'author_uid',
        'handler' => 'views_handler_relationship',
        'label' => t('Author user'),
      ),
      'argument' => array(
        'handler' => 'views_handler_argument_author_uid',
        'numeric' => TRUE,
        'validate type' => 'uid',
      ),
    ),
    'status' => array(
      'title' => 'Status',
      'help' => 'status of follow dataset',
      'field' => array(
        'handler' => 'views_handler_field',
        'click sortable' => FALSE,
      ),
      'filter' => array(
        'handler' => 'views_handler_filter_numeric',
      ),
      'sort' => array(
        'handler' => 'views_handler_sort',
      ),
    ),

    'created' => array(
      'title' => 'created',
      'help' => 'time stamp time()',
      'field' => array(
        'handler' => 'views_handler_field_date',
        'click sortable' => FALSE,
      ),
    ),
    'changed' => array(
      'title' => 'Changed',
      'help' => 'time stamp time()',
      'field' => array(
        'handler' => 'views_handler_field_date',
        'click sortable' => FALSE,
      ),
      'sort' => array(
        'handler' => 'views_handler_sort',
      ),
    ),
  );

  $data['follow_unfollow_statistics']['table']['join'] = array(
    'node' => array(
      'left_field' => 'nid',
      'field' => 'nid',
    ),
    'taxonomy_term_data' => array(
      'left_field' => 'tid',
      'field' => 'tid',
    ),
    'users' => array(
      'left_field' => 'uid',
      'field' => 'uid',
    ),
    'users' => array(
      'left_field' => 'uid',
      'field' => 'author_uid',
    ),
  );

  return $data;
}
